log4cxx::helpers Namespace Reference

We need to double some logic from LOG4CXX_PTR_DEF or else we are unable to override the comparison operator, which we need to properly fix LOGCXX-394. More...

## Namespaces

| SimpleDateFormatImpl
| ThreadLaunch

## Classes

class | AbsoluteTimeDateFormat
| Formats a date in the format HH:mm:ss,SSS for example, "15:49:37,459". More...
class | AppenderAttachableImpl
class | APRInitializer
class | BindException
| Signals that an error occurred while attempting to bind a socket to a local address and port. More...
class | BufferedOutputStream
| Abstract class for writing to character streams. More...
class | BufferedWriter
| Writes text to a character-output stream buffering requests to increase efficiency. More...
class | ByteArrayInputStream
| InputStream implemented on top of a byte array. More...
class | ByteArrayOutputStream
| OutputStream implemented on top of std::vector. More...
class | ByteBuffer
| A byte buffer. More...
class | CharMessageBuffer
| This class is used by the LOG4CXX_INFO and similar macros to support insertion operators in the message parameter. More...
class | CharsetDecoder
| An abstract engine to transform a sequences of bytes in a specific charset into a LogString. More...
class | CharsetEncoder
| An engine to transform LogStrings into bytes for the specific character set. More...
class | Class
class | ClassNotFoundException
| Thrown when an application tries to load in a class through its string name but no definition for the class with the specified name could be found. More...
class | ClassRegistration
class | ClosedChannelException
class | Condition
| This class provides a means for one thread to suspend exception until notified by another thread to resume. More...
class | ConnectException
| Signals that an error occurred while attempting to connect a socket to a remote address and port. More...
class | CyclicBuffer
| CyclicBuffer is used by other appenders to hold instances of LoggingEvent for immediate or deferred display. More...
class | DatagramPacket
| This class represents a datagram packet. More...
class | DatagramSocket
| This class represents a socket for sending and receiving datagram packets. More...
class | Date
| Simple transcoder for converting between external char and wchar_t strings and internal strings. More...
class | DateFormat
| DateFormat is an abstract class for date/time formatting patterned after java.text.DateFormat. More...
class | DateLayout
| This abstract layout takes care of all the date related options and formatting work. More...
class | DateTimeDateFormat

     Formats a date in the format <b>dd MMM yyyy HH:mm:ss,SSS</b> for example,

"06 Nov 1994 15:49:37,459". More...

class | DOMException
class | Exception
| The class Exception and its subclasses indicate conditions that a reasonable application might want to catch. More...
class | FileInputStream
| InputStream implemented on top of APR file IO. More...
class | FileOutputStream
| OutputStream implemented on top of APR file IO. More...
class | FileWatchdog
| Check every now and then that a certain file has not changed. More...
class | IllegalArgumentException
| Thrown to indicate that a method has been passed an illegal or inappropriate argument. More...
class | IllegalMonitorStateException
class | IllegalStateException
class | InetAddress
class | InputStream
| Abstract class for reading from character streams. More...
class | InputStreamReader
| Class for reading from character streams. More...
class | InstantiationException
| Thrown when an application tries to create an instance of a class using the newInstance method in class Class, but the specified class object cannot be instantiated because it is an interface or is an abstract class. More...
class | Integer
class | InterruptedException
class | InterruptedIOException
| Signals that an I/O operation has been interrupted. More...
class | IOException
| Signals that an I/O exception of some sort has occurred. More...
class | ISO8601DateFormat
| Formats a date in the format yyyy-MM-dd HH:mm:ss,SSS for example "1999-11-27 15:49:37,459". More...
class | Loader
class | Locale
class | LogLog
| This class used to output log statements from within the log4cxx package. More...
class | MessageBuffer
| This class is used by the LOG4CXX_INFO and similar macros to support insertion operators in the message parameter. More...
class | MissingResourceException
class | Mutex
class | MutexException
class | NoSuchElementException
class | NullPointerException
| Thrown when an application attempts to use null in a case where an object is required. More...
class | Object
| base class for java-like objects. More...
class | ObjectImpl
| Implementation class for Object. More...
class | ObjectOutputStream
| Emulates java serialization. More...
class | ObjectPtr
class | ObjectPtrBase
class | ObjectPtrT
| smart pointer to a Object descendant More...
class | OnlyOnceErrorHandler
| The `OnlyOnceErrorHandler` implements log4cxx's default error handling policy which consists of emitting a message for the first error in an appender and ignoring all following errors. More...
class | OptionConverter
| A convenience class to convert property values to specific types. More...
class | OutputStream
| Abstract class for writing to character streams. More...
class | OutputStreamWriter
| Abstract class for writing to character streams. More...
class | Pool
class | PoolException
class | Properties
class | PropertyResourceBundle
| PropertyResourceBundle is a concrete subclass of ResourceBundle that manages resources for a locale using a set of static strings from a property file. More...
class | Reader
| Abstract class for reading from character streams. More...
class | RelativeTimeDateFormat
| Formats a date by printing the number of seconds elapsed since the start of the application. More...
class | ResourceBundle
| Resource bundles contain locale-specific objects. More...
class | RuntimeException
| RuntimeException is the parent class of those exceptions that can be thrown during the normal operation of the process. More...
class | ServerSocket
class | SimpleDateFormat
| Concrete class for formatting and parsing dates in a locale-sensitive manner. More...
class | Socket
class | SocketException
| Thrown to indicate that there is an error in the underlying protocol, such as a TCP error. More...
class | SocketOutputStream
class | SocketTimeoutException
| Signals that an I/O operation has been interrupted. More...
class | StrftimeDateFormat
| Concrete class for formatting and parsing dates in a locale-sensitive manner. More...
class | StrictMath
| The class StrictMath contains methods for performing basic numeric operations. More...
class | StringHelper
| String manipulation routines. More...
class | StringTokenizer
class | synchronized
| utility class for objects multi-thread synchronization. More...
class | SyslogWriter
| SyslogWriter is a wrapper around the DatagramSocket class it writes text to the specified host on the port 514 (UNIX syslog) More...
class | System
| The System class contains several useful class fields and methods. More...
class | SystemErrWriter
| Abstract class for writing to character streams. More...
class | SystemOutWriter
| Abstract class for writing to character streams. More...
class | Thread
| This class implements an approximation of java.util.Thread. More...
class | ThreadException
class | ThreadLocal
| This class provides thread-local variables. More...
class | ThreadSpecificData
| This class contains all the thread-specific data in use by log4cxx. More...
class | TimeZone
class | Transcoder
| Simple transcoder for converting between external char and wchar_t strings and internal strings. More...
class | TranscoderException
class | Transform
| Utility class for transforming strings. More...
class | UniCharMessageBuffer
| This class is designed to support insertion operations in the message argument to the LOG4CXX_INFO and similar macros and is not designed for general purpose use. More...
class | UnknownHostException
class | WideMessageBuffer
| This class is designed to support insertion operations in the message argument to the LOG4CXX_INFO and similar macros and is not designed for general purpose use. More...
class | Writer
| Abstract class for writing to character streams. More...
class | XMLDOMDocument
| The XMLDOMDocument interface represents an entire XML document. More...
class | XMLDOMElement
| The XMLDOMElement interface represents an element in an XML document. More...
class | XMLDOMNode
| The XMLDOMNode interface is the primary datatype for the entire Document Object Model. More...
class | XMLDOMNodeList
| The XMLDOMNodeList interface provides the abstraction of an ordered collection of nodes, without defining or constraining how this collection is implemented. More...

## Typedefs

typedef ObjectPtrT< Object > | ObjectPtr
typedef std::ios_base &(* | ios_base_manip) (std::ios_base &)
typedef void *(* | Runnable) (apr_thread_t *thread, void *data)
typedef helpers::ObjectPtrT< XMLDOMNode > | XMLDOMNodePtr
typedef helpers::ObjectPtrT< XMLDOMDocument > | XMLDOMDocumentPtr
typedef helpers::ObjectPtrT< XMLDOMNodeList > | XMLDOMNodeListPtr
typedef ObjectPtrT< ObjectOutputStream > | ObjectOutputStreamPtr

## Functions

| LOG4CXX_PTR_DEF (AppenderAttachableImpl)
| LOG4CXX_PTR_DEF (BufferedOutputStream)
| LOG4CXX_LIST_DEF (ByteList, unsigned char)
| LOG4CXX_PTR_DEF (ByteArrayInputStream)
| LOG4CXX_PTR_DEF (ByteArrayOutputStream)
| LOG4CXX_PTR_DEF (CharsetDecoder)
| LOG4CXX_PTR_DEF (CharsetEncoder)
| LOG4CXX_PTR_DEF (DatagramPacket)
| LOG4CXX_PTR_DEF (DatagramSocket)
| LOG4CXX_PTR_DEF (Date)
| LOG4CXX_PTR_DEF (DateFormat)
| LOG4CXX_PTR_DEF (FileInputStream)
| LOG4CXX_PTR_DEF (FileOutputStream)
| LOG4CXX_PTR_DEF (InetAddress)
| LOG4CXX_LIST_DEF (InetAddressList, InetAddressPtr)
| LOG4CXX_PTR_DEF (InputStream)
| LOG4CXX_PTR_DEF (InputStreamReader)
| LOG4CXX_PTR_DEF (Integer)
template<class V >
std::basic_ostream< char > & | operator<< (CharMessageBuffer &os, const V &val)
template<class V >
UniCharMessageBuffer::uostream & | operator<< (UniCharMessageBuffer &os, const V &val)
template<class V >
std::basic_ostream< wchar_t > & | operator<< (WideMessageBuffer &os, const V &val)
template<class V >
std::ostream & | operator<< (MessageBuffer &os, const V &val)
| LOG4CXX_PTR_DEF (Object)
| LOG4CXX_PTR_DEF (ObjectOutputStream)
| LOG4CXX_PTR_DEF (OutputStream)
| LOG4CXX_PTR_DEF (OutputStreamWriter)
| LOG4CXX_PTR_DEF (PropertyResourceBundle)
| LOG4CXX_PTR_DEF (Reader)
| LOG4CXX_PTR_DEF (ResourceBundle)
| LOG4CXX_LIST_DEF (PatternTokenList, log4cxx::helpers::SimpleDateFormatImpl::PatternToken *)
| LOG4CXX_PTR_DEF (Socket)
| LOG4CXX_PTR_DEF (SocketOutputStream)
| LOG4CXX_PTR_DEF (TimeZone)
| LOG4CXX_PTR_DEF (Writer)
| LOG4CXX_PTR_DEF (XMLDOMNode)
| LOG4CXX_PTR_DEF (XMLDOMElement)
| LOG4CXX_PTR_DEF (XMLDOMDocument)
| LOG4CXX_PTR_DEF (XMLDOMNodeList)

## Detailed Description

We need to double some logic from LOG4CXX_PTR_DEF or else we are unable to override the comparison operator, which we need to properly fix LOGCXX-394.

https://issues.apache.org/jira/browse/LOGCXX-394

## Typedef Documentation

## ios_base_manip

typedef std::ios_base&(* ios_base_manip) (std::ios_base &)

## ObjectOutputStreamPtr

typedef ObjectPtrT<ObjectOutputStream> ObjectOutputStreamPtr

## ObjectPtr

typedef ObjectPtrT< Object > ObjectPtr

## Runnable

typedef void*( * Runnable) (apr_thread_t *thread, void *data)

## XMLDOMDocumentPtr

typedef helpers::ObjectPtrT<XMLDOMDocument> XMLDOMDocumentPtr

## XMLDOMNodeListPtr

typedef helpers::ObjectPtrT<XMLDOMNodeList> XMLDOMNodeListPtr

## XMLDOMNodePtr

typedef helpers::ObjectPtrT<XMLDOMNode> XMLDOMNodePtr

## Function Documentation

## LOG4CXX_LIST_DEF() [1/3]

LOG4CXX_LIST_DEF | ( | ByteList | ,
|  | unsigned | char
| ) |  |

## LOG4CXX_LIST_DEF() [2/3]

log4cxx::helpers::LOG4CXX_LIST_DEF | ( | PatternTokenList | ,
|  | log4cxx::helpers::SimpleDateFormatImpl::PatternToken * |
| ) |  |

## LOG4CXX_LIST_DEF() [3/3]

log4cxx::helpers::LOG4CXX_LIST_DEF | ( | InetAddressList | ,
|  | InetAddressPtr |
| ) |  |

## LOG4CXX_PTR_DEF() [1/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | CharsetDecoder |  | ) |

## LOG4CXX_PTR_DEF() [2/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | CharsetEncoder |  | ) |

## LOG4CXX_PTR_DEF() [3/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | ResourceBundle |  | ) |

## LOG4CXX_PTR_DEF() [4/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | TimeZone |  | ) |

## LOG4CXX_PTR_DEF() [5/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | Integer |  | ) |

## LOG4CXX_PTR_DEF() [6/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | InetAddress |  | ) |

## LOG4CXX_PTR_DEF() [7/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | Writer |  | ) |

## LOG4CXX_PTR_DEF() [8/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | PropertyResourceBundle |  | ) |

## LOG4CXX_PTR_DEF() [9/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | BufferedOutputStream |  | ) |

## LOG4CXX_PTR_DEF() [10/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | Date |  | ) |

## LOG4CXX_PTR_DEF() [11/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | OutputStream |  | ) |

## LOG4CXX_PTR_DEF() [12/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | SocketOutputStream |  | ) |

## LOG4CXX_PTR_DEF() [13/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | OutputStreamWriter |  | ) |

## LOG4CXX_PTR_DEF() [14/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | FileOutputStream |  | ) |

## LOG4CXX_PTR_DEF() [15/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | InputStream |  | ) |

## LOG4CXX_PTR_DEF() [16/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | Reader |  | ) |

## LOG4CXX_PTR_DEF() [17/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | ByteArrayOutputStream |  | ) |

## LOG4CXX_PTR_DEF() [18/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | XMLDOMNode |  | ) |

## LOG4CXX_PTR_DEF() [19/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | XMLDOMElement |  | ) |

## LOG4CXX_PTR_DEF() [20/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | ByteArrayInputStream |  | ) |

## LOG4CXX_PTR_DEF() [21/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | Socket |  | ) |

## LOG4CXX_PTR_DEF() [22/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | DateFormat |  | ) |

## LOG4CXX_PTR_DEF() [23/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | InputStreamReader |  | ) |

## LOG4CXX_PTR_DEF() [24/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | FileInputStream |  | ) |

## LOG4CXX_PTR_DEF() [25/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | ObjectOutputStream |  | ) |

## LOG4CXX_PTR_DEF() [26/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | XMLDOMDocument |  | ) |

## LOG4CXX_PTR_DEF() [27/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | Object |  | ) |

## LOG4CXX_PTR_DEF() [28/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | AppenderAttachableImpl |  | ) |

## LOG4CXX_PTR_DEF() [29/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | XMLDOMNodeList |  | ) |

## LOG4CXX_PTR_DEF() [30/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | DatagramSocket |  | ) |

## LOG4CXX_PTR_DEF() [31/31]

log4cxx::helpers::LOG4CXX_PTR_DEF | ( | DatagramPacket |  | ) |

## operator<<() [1/4]

std::basic_ostream<char>& log4cxx::helpers::operator<< | ( | CharMessageBuffer & | os,
|  | const V & | val
| ) |  |

## operator<<() [2/4]

UniCharMessageBuffer::uostream& log4cxx::helpers::operator<< | ( | UniCharMessageBuffer & | os,
|  | const V & | val
| ) |  |

## operator<<() [3/4]

std::basic_ostream<wchar_t>& log4cxx::helpers::operator<< | ( | WideMessageBuffer & | os,
|  | const V & | val
| ) |  |

## operator<<() [4/4]

std::ostream& log4cxx::helpers::operator<< | ( | MessageBuffer & | os,
|  | const V & | val
| ) |  |